require 'nokogiri'
require 'open-uri'
require 'json'

module BeatportPlay
  module Scraper
    # Returns an enumerable containing the title of each song in the Beatport Top 10.
    def self.get_top_10
      song_titles = []

      doc = Nokogiri::HTML(open('http://beatport.com'))

      # Every Beatport Top 10 song has a div.playWrapper that has a child
      # span.play-queue.play-queue-medium element with a json-data attribute that
      # contains all the song data.
      doc.css('div.playWrapper > span.play-queue.play-queue-medium').each do |song|
        # In here we have access to the 'data-json' attribute of each song.
        song_titles << JSON.parse(song['data-json'])['title']
      end

      song_titles
    end
  end
end
